Index: /trunk/kernel/devices/dev_nic.c
===================================================================
--- /trunk/kernel/devices/dev_nic.c	(revision 656)
+++ /trunk/kernel/devices/dev_nic.c	(revision 657)
@@ -2,5 +2,5 @@
  * dev_nic.c - NIC (Network Controler) generic device API implementation.
  * 
- * Author  Alain Greiner    (2016,2017,2018,2019)
+ * Author  Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -24,15 +24,192 @@
 #include <hal_kernel_types.h>
 #include <hal_special.h>
+#include <hal_uspace.h>
+#include <remote_buf.h>
 #include <printk.h>
 #include <chdev.h>
 #include <thread.h>
+#include <socket.h>
 #include <hal_drivers.h>
 #include <dev_nic.h>
+#include <vfs.h>
+#include <shared_socket.h>
 
 /////////////////////////////////////////////////////////////////////////////////////////
-// Extern global variables
+//                 Extern global variables
 /////////////////////////////////////////////////////////////////////////////////////////
 
 extern chdev_directory_t  chdev_dir;         // allocated in kernel_init.c
+
+////////////////////////////////////////////////////////////////////////////////////////////
+// This static function is used by the dev_nic_rx_handle_tcp() & dev_nic_tx_handle_tcp()
+// functions to check acceptability of a given sequence number. It returns true when 
+// the <seq> argument is contained in a wrap-around window defined by the <min> and <max>
+// arguments. The window wrap-around when (min > max).
+////////////////////////////////////////////////////////////////////////////////////////////
+// @ seq   : [in] value to be checked.
+// @ min   : [in] first  base.
+// @ max   : [in] window size.
+////////////////////////////////////////////////////////////////////////////////////////////
+static inline bool_t is_in_window( uint32_t seq,
+                                   uint32_t min,
+                                   uint32_t max )
+{
+    if( max >= min )    // no wrap_around => only one window [min,max]
+    {
+        return( (seq >= min) && (seq <= max) ); 
+    }
+    else                // window wrap-around => two windows [min,0xFFFFFFFF] and [0,max]
+    {
+        return( (seq <= max) || (seq >= min) );
+    }
+}  
+
+////////////////////////////////////////////////////////////////////////////////////////////
+// this static function compute a channel index in range [0,nic_channelx[ from
+// a remote IP address and remote port.
+// TODO this function should be provided by the NIC driver.
+////////////////////////////////////////////////////////////////////////////////////////////
+// @ addr     : [in] IP address.
+// @ port     : [in] TCP/UDP port.
+////////////////////////////////////////////////////////////////////////////////////////////
+static inline uint32_t dev_nic_channel_index( uint32_t addr,
+                                              uint16_t port )
+{
+    // get number of NIC channels
+    uint32_t nic_channels = LOCAL_CLUSTER->nb_nic_channels;
+ 
+    // compute NIC channel index
+    return ( ((addr     ) & 0xFF) ^
+             ((addr > 8 ) & 0xFF) ^
+             ((addr > 16) & 0xFF) ^
+             ((addr > 24) & 0xFF) ^
+             ((port     ) & 0xFF) ^
+             ((port > 8 ) & 0xFF) ) % nic_channels;
+}
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This static function computes the checksum for an IP packet header.
+// The "checksum" field itself is not taken into account for this computation.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ buffer      : [in] pointer on IP packet header (20 bytes)
+// @ return the checksum value on 16 bits
+////////////////////////////////////////////////////////////////////////////////////////
+uint16_t dev_nic_ip_checksum( uint8_t  * buffer )
+{
+    uint32_t   i;           
+    uint32_t   cs;      // 32 bits accumulator
+    uint16_t * buf;     
+    
+    buf = (uint16_t *)buffer;
+
+    // compute checksum 
+    for( i = 0 , cs = 0 ; i < 10 ; i++ )
+    {
+        if( i != 5 )  cs += buf[i];
+    }
+
+    // one's complement
+    return ~cs;
+}
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This static function computes the checksum for an UDP packet defined by 
+// the <buffer> and <size> arguments.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ buffer      : [in] pointer on UDP packet base.
+// @ size        : [in] number of bytes in this packet (including header).
+// @ return the checksum value on 16 bits
+////////////////////////////////////////////////////////////////////////////////////////
+uint16_t dev_nic_udp_checksum( uint8_t  * buffer,
+                               uint32_t   size )
+{
+    uint32_t   i;           
+    uint32_t   carry;
+    uint32_t   cs;      // 32 bits accumulator
+    uint16_t * buf;     
+    uint32_t   max;     // number of uint16_t in packet
+    
+    // compute max & buf
+    buf = (uint16_t *)buffer;
+    max = size >> 1;
+
+    // extend buffer[] if required
+    if( size & 1 )
+    {
+        max++;
+        buffer[size] = 0;
+    }
+
+    // compute checksum for UDP packet
+    for( i = 0 , cs = 0 ; i < size ; i++ )  cs += buf[i];
+
+    // handle carry
+    carry = (cs >> 16);
+    if( carry ) 
+    {
+        cs += carry; 
+        carry = (cs >> 16);
+        if( carry ) cs += carry;
+    } 
+
+    // one's complement
+    return ~cs;
+}
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This static function computes the checksum for a TCP segment defined by
+// the <buffer> and <size> arguments.
+// It includes the pseudo header defined by the <src_ip_addr>, <dst_ip_addr>,
+// <size> arguments, and by the TCP_PROTOCOL code.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ buffer      : [in] pointer on TCP segment base.
+// @ size        : [in] number of bytes in this segment (including header).
+// @ src_ip_addr : [in] source IP address (pseudo header)
+// @ dst_ip_addr : [in] destination IP address (pseudo header)
+// @ return the checksum value on 16 bits
+////////////////////////////////////////////////////////////////////////////////////////
+uint16_t dev_nic_tcp_checksum( uint8_t  * buffer,
+                               uint32_t   size,
+                               uint32_t   src_ip_addr,
+                               uint32_t   dst_ip_addr )
+{
+    uint32_t   i;           
+    uint32_t   carry;
+    uint32_t   cs;      // 32 bits accumulator
+    uint16_t * buf;
+    uint32_t   max;     // number of uint16_t in segment
+
+    // compute max & buf
+    buf = (uint16_t *)buffer;
+    max = size >> 1;
+
+    // extend buffer[] if required
+    if( size & 1 )
+    {
+        max++;
+        buffer[size] = 0;
+    }
+
+    // compute checksum for TCP segment
+    for( i = 0 , cs = 0 ; i < size ; i++ )  cs += buf[i];
+
+    // complete checksum for pseudo-header
+    cs += src_ip_addr;
+    cs += dst_ip_addr;
+    cs += PROTOCOL_TCP;
+    cs += size;
+
+    // handle carry
+    carry = (cs >> 16);
+    if( carry ) 
+    {
+        cs += carry; 
+        carry = (cs >> 16);
+        if( carry ) cs += carry;
+    } 
+
+    // one's complement
+    return ~cs;
+}
 
 //////////////////////////////////
Index: /trunk/kernel/devices/dev_nic.h
===================================================================
--- /trunk/kernel/devices/dev_nic.h	(revision 656)
+++ /trunk/kernel/devices/dev_nic.h	(revision 657)
@@ -2,5 +2,5 @@
  * dev_nic.h - NIC (Network Controler) generic device API definition.
  * 
- * Author  Alain Greiner    (2016,2017,2018)
+ * Author  Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -27,48 +27,111 @@
 #include <kernel_config.h>
 #include <hal_kernel_types.h>
+#include <remote_busylock.h>
+#include <remote_buf.h>
+#include <xlist.h>
+
+/****  Forward declarations  ****/
+
+struct chdev_s;
 
 /*****************************************************************************************
  *     Generic Network Interface Controler definition
  *
- * This device provide access to an external Gigabit Ethernet network controler.
- * It assume that the NIC hardware peripheral handles two packets queues for sent (TX)
- * and received (RX) packets. Packets are (Ethernet/IPV4).
+ * This device provides access to a generic Gigabit Ethernet network controler.
+ * It assumes that the NIC hardware peripheral handles two packets queues for sent (TX)
+ * and received (RX) packets.
+ *
+ * The supported protocols stack is : Ethernet / IPV4 / TCP or UDP
  * 
- * The NIC device is handling an (infinite) stream of packets to or from the network. 
+ * 1) hardware assumptions
+ *
+ * The NIC device is handling two (infinite) streams of packets to or from the network. 
  * It is the driver responsibility to move the RX packets from the NIC to the RX queue,
  * and the TX packets from the TX queue to the NIC.
  *
- * AS the RX and TX queues are independant, there is one NIC-RX device descriptor 
- * to handle RX packets, and another NIC-TX device descriptor to handle TX packets.
- * In order to improve throughput, the hardware NIC controller can optionnally implement
- * multiple channels:
- * - The RX channels are indexed by an hash key derived from the source IP address.
- * - The TX channels are indexed by an hash key derived from the destination IP address.
- * These 2*N devices, and 2*N associated server threads, are distributed in 2*N clusters.
- * The  2*N server threads implement the protocols stack. The RX server threads block
- * and deschedule when the RX queue is empty. The TX server stack block and deschedule
- * when the queue is full. 
- *
- * It is the driver responsibily to re-activate a blocked server thread when
- * the queue state is modified: not full for TX, or not empty for RX.
+ * AS the RX and TX queues are independant, there is one NIC_RX device descriptor 
+ * to handle RX packets, and another NIC_TX device descriptor to handle TX packets.
+ *
+ * In order to improve throughput, the NIC controller can implement multiple (N) channels.
+ * In this case, the channel index is defined by an hash function computed from the remote
+ * IP address and port. This index is computed by the hardware for an RX packet, and is 
+ * computed by the kernel for a TX packet, using a specific driver function. TODO ...
+ * The 2*N chdevs, and the associated server threads implementing the protocols stack,
+ * are distributed in 2*N different clusters.
+ *
+ * 2) User API
+ * 
+ * On the user side, ALMOS-MKH implements the POSIX socket API. 
+ * The kernel functions implementing the socket related syscalls are :
+ * - dev_nic_socket()    : create a local socket registered in process fd_array[].
+ * - dev_nic_bind()      : attach a local IP address and port to a local socket.
+ * - dev_nic_listen()    : local server makes a passive open.
+ * - dev_nic_connect()   : local client makes an active open to a remote server.
+ * - dev_nic_accept()    : local server accept a new remote client.
+ * - dev_nic_send()      : send data on a connected socket.
+ * - dev_nic_recv()      : receive data on a connected socket.
+ * - dev_nic_sendto()    : send a packet to a remote (IP address/port). 
+ * - dev_nic_recvfrom()  : receive a paket from a remote (IP address/port).
+ * - dev_nic_close()     : close a socket
+ *
+ * 3) TX stream
+ *
+ * The internal API between the client threads and the TX server thread defines
+ * the 3 following commands: 
+ *   . SOCKET_TX_CONNECT : request to execute the 3 steps TCP connection handshake.
+ *   . SOCKET_TX_SEND    : send data to a remote socket (UDP or TCP).
+ *   . SOCKET_TX_CLOSE   : request to execute the 3 steps TCP close handshake.
+ *
+ * - These 3 commands are blocking for the client thread that registers the command in the
+ *   socket descriptor, blocks on the BLOCKED_IO condition, and deschedules.
+ * - The TX server thread is acting as a multiplexer. It scans the list of attached sockets,
+ *   to handle all valid commands: one UDP packet or TCP segment per iteration.
+ *   It uses the user buffer defined by the client thread, and attached to socket descriptor,
+ *   as a retransmission buffer. It blocks and deschedules on the BLOCKED_CLIENT condition,
+ *   when there is no more active TX command registered in any socket. It is re-activated 
+ *   by the first client thread registering a new TX command in the socket descriptor.
+ *   It unblocks a client thread only when a command is fully completed. It signals errors
+ *   to the client thread using the tx_error field in socket descriptor.
+ *
+ * 4) RX stream
+ *
+ * The communication between the RX server thread and the client threads expecting data
+ * is done through receive buffers (one private buffer per socket) that are handled
+ * as single-writer / single reader-FIFOs, called rx_buf. 
+ * - The RX server thread is acting as a demultiplexor: it handle one TCP segment or UDP
+ *   packet per iteration, and register the data in the rx_buf of the socket matching
+ *   the packet. It simply discard all packets that does not match a registered socket.
+ *   When a client thread is registered in the socket descriptor, the RX server thread
+ *   unblocks this client thread as soon as there is data available in rx_buf.
+ *   It blocks and deschedules on the BLOCKED_ISR condition when there is no more packets
+ *   in the NIC_RX queue. It is unblocked by the hardware ISR.
+ * - The client thread simply access the rx_buf attached to socket descriptor, and consumes
+ *   the available data when the rx_buf is non empty. It blocks on the BLOCKED_IO condition,
+ *   and deschedules when the rx_buf is empty. 
+ *
+ * 5) R2T queue
+ *
+ * To implement the TCP "3 steps handshake" protocol, the RX server thread can directly
+ * request the associated TX server thread to send control packets in  the TX stream, 
+ * using a dedicate R2T (RX to TX) FIFO stored in the socket descriptor.
+ *
+ * 6) NIC driver API
+ *
+ * The generic NIC device "driver" API defines the following commands to the NIC driver:
+ * - READABLE : returns true if at least one RX paquet is available in RX queue.
+ * - WRITABLE : returns true if at least one empty slot is available in TX queue.
+ * - READ     : consume one packet from the RX queue.
+ * - WRITE    : produce one packet to the TX queue.
+ * All RX or TX paquets are sent or received in standard 2 Kbytes kernel buffers,
+ * that are dynamically allocated by the protocols stack. 
+ *
+ * The actual TX an RX queues structures depends on the hardware NIC implementation,
+ * and are defined in the HAL specific driver code. 
  *
  * WARNING: the WTI mailboxes used by the driver ro receive events from the hardware
  * (available RX packet, or available free TX slot, for a given channel), must be 
  * statically allocated during the kernel initialisation phase, and must be 
- * routed to the cluster containing the associated device descriptor and server thread.
- * to simplify the server thread re-activation.
- *
- * Finally, the generic NIC device API defines the following commands:
- * - READABLE : returns true if at least one RX paquet is available in RX queue.
- * - WRITABLE : returns true if atleast one empty slot is available in TX queue.
- * - READ     : consume one packet from the RX queue.
- * - WRITE    : produce one packet fto the TX queue.
- * All RX or TX paquets are sent or received in standard 2 Kbytes kernel buffers,
- * that are dynamically allocated by the protocols stack. The structure pkd_t
- * defining a packet descriptor is defined below, and contain the buffer pointer
- * and the actual Ethernet packet Length.
- *
- * The actual TX an RX queues structures depends on the hardware NIC implementation,
- * and are defined in the driver code. 
+ * routed to the cluster containing the associated TX/RX chdev and server thread.
+ *
  *****************************************************************************************/
 
@@ -78,32 +141,59 @@
 
 /******************************************************************************************
- * This defines the extension for the generic IOC device.
+ *   Various constants used by the Protocols stack
+ *****************************************************************************************/
+
+#define SRC_MAC_54             0x54
+#define SRC_MAC_32             0x32
+#define SRC_MAC_10             0x10
+#define DST_MAC_54             0x54
+#define DST_MAC_32             0x32
+#define DST_MAC_10             0x10
+
+#define TCP_HEAD_LEN           20
+#define UDP_HEAD_LEN           8
+#define IP_HEAD_LEN            20
+#define ETH_HEAD_LEN           14
+
+#define PROTOCOL_UDP           0x11
+#define PROTOCOL_TCP           0x06
+
+#define TCP_ISS                0x10000
+
+#define PAYLOAD_MAX_LEN        1500         // max payload for and UDP packet or a TCP segment
+
+#define TCP_FLAG_FIN           0x01
+#define TCP_FLAG_SYN           0x02
+#define TCP_FLAG_RST           0x04
+#define TCP_FLAG_PSH           0x08
+#define TCP_FLAG_ACK           0x10
+#define TCP_FLAG_URG           0x20
+
+#define NIC_RX_BUF_SIZE        0x100000     // 1 Mbytes
+#define NIC_R2T_QUEUE_SIZE     0x64         // smallest KCM size
+#define NIC_CRQ_QUEUE_SIZE     0x8          // 8 * sizeof(sockaddr_t) = smallest KCM size
+#define NIC_PKT_MAX_SIZE       1500         // for Ethernet
+#define NIC_KERNEL_BUF_SIZE    2000         // for on ETH/IP/TCP packet
+
+/*****************************************************************************************
+ * This defines the extension for the generic NIC device.
  * The actual queue descriptor depends on the implementation.
- *****************************************************************************************/
+ *
+ * WARNING : for all NIC_TX and NIC_RX chdevs, the xlist rooted in in the chdev
+ *           ("wait_root" and "wait_lock" fields) is actually a list of sockets.
+ ****************************************************************************************/
 
 typedef struct nic_extend_s
 {
-    void     * queue;     /*! local pointer on the packets queue descriptor (RX or TX)   */
+    void         * queue;       /*! local pointer on NIC queue descriptor (RX or TX)    */
 }
 nic_extend_t;
 
-/******************************************************************************************
- * This structure defines the Ethernet/IPV4 packet descriptor, that is sent to,
- * or received from, the protocols stack.
- *****************************************************************************************/
-
-typedef struct pkd_s
-{
-    char      * buffer;   /*! local pointer on 2 Kbytes buffer containing packet         */  
-    uint32_t    length;   /*! actual number of bytes                                     */
-}
-pkd_t;
-
-/******************************************************************************************
+/*****************************************************************************************
  * This enum defines the various implementations of the generic NIC peripheral.
  * This array must be kept consistent with the define in the arch_info.h file.
- *****************************************************************************************/
-
-enum nic_impl_e
+ ****************************************************************************************/
+
+typedef enum nic_impl_e
 {
     IMPL_NIC_CBF =   0,     
@@ -112,14 +202,17 @@
 nic_impl_t;
 
-/******************************************************************************************
- * This defines the (implementation independant) command  passed to the NIC driver.
- *****************************************************************************************/
+/****************************************************************************************
+ * This defines the (implementation independant) commands to access the NIC hardware.
+ * These commands are registered by the NIC_TX and NIC_RX server threads in the
+ * server thread descriptor, to be used by the NIC driver. 
+ * The buffer is always a 2K bytes kernel buffer, containing an Ethernet packet.
+ ****************************************************************************************/
 
 typedef enum nic_cmd_e
 {
-    NIC_CMD_WRITABLE = 0,  /*! test TX queue not full (for a given length packet)        */
-    NIC_CMD_WRITE    = 1,  /*! put one (given length) packet to TX queue                 */
-    NIC_CMD_READABLE = 2,  /*! test RX queue not empty (for any length packet)           */
-    NIC_CMD_READ     = 3,  /*! get one (any length) packet from RX queue                 */
+    NIC_CMD_WRITABLE  = 10,   /*! test TX queue not full (for a given packet length)    */
+    NIC_CMD_WRITE     = 11,   /*! put one (given length) packet to TX queue             */
+    NIC_CMD_READABLE  = 12,   /*! test RX queue not empty (for any packet length)       */
+    NIC_CMD_READ      = 13,   /*! get one (any length) packet from RX queue             */
 }
 nic_cmd_t;
@@ -127,12 +220,75 @@
 typedef struct nic_command_s
 {
-    xptr_t      dev_xp;   /*! extended pointer on device descriptor                      */
-    nic_cmd_t   cmd;      /*! requested operation type                                   */
-    char      * buffer;   /*! local pointer on 2 Kbytes buffer containing packet         */  
-    uint32_t    length;   /*! actual number of bytes                                     */
-    bool_t      status;   /*! return true if writable or readable (depend on command)    */
-    uint32_t    error;    /*! return an error from the hardware (0 if no error)          */
+    xptr_t      dev_xp;       /*! extended pointer on NIC chdev descriptor              */
+    nic_cmd_t   type;         /*! command type                                          */
+    uint8_t   * buffer;       /*! local pointer on buffer (kernel or user space)        */  
+    uint32_t    length;       /*! number of bytes in buffer                             */
+    uint32_t    status;       /*! return value (depends on command type)                */
+    uint32_t    error;        /*! return an error from the hardware (0 if no error)     */
 }
 nic_command_t;
+
+/***************************************************************************************** 
+ * This structure defines a socket descriptor. In order to parallelize the transfers,
+ * the set of all registered sockets is split in several subsets.
+ * The number of subsets is the number of  NIC channels. 
+ * The distribution key is computed from the (remote_addr/remote_port) couple.
+ * This computation is done by the NIC hardware for RX packets, 
+ * and by the dev_nic_connect() function for the TX packets.
+ *
+ * A socket is attached to the NIC_TX[channel] & NIC_RX[channel] chdevs.
+ * Each socket descriptor allows the TX and TX server threads to access various buffers:
+ * - the user "send" buffer contains the data to be send by the TX server thread.
+ * - the kernel "receive" buffer contains the data received by the RX server thread.
+ * - the kernel "r2t" buffer allows the RX server thread to make direct requests
+ *   to the associated TX server (to implement the TCP 3 steps handshake).
+ *
+ * The synchronisation mechanism between the clients threads and the servers threads
+ * is different for TX and RX transfers:
+ *
+ * 1) For a TX transfer, it can exist only one client thread for a given socket,
+ *    the transfer is always initiated by the local process, and all TX commands
+ *    (CONNECT/SEND/CLOSE) are blocking for the client thread. The user buffer is
+ *    used by TCP to handle retransmissions when required.in case of re
+ *    The client thread registers the command in the thread descriptor, registers itself
+ *    in the socket descriptor, unblocks the TX server thread from the BLOCKED_CLIENT 
+ *    condition, blocks itself on the BLOCKED_IO condition, and deschedules. 
+ *    When the command is completed, the TX server thread unblocks the client thread.
+ *    The TX server blocks itself on the BLOCKED_CLIENT condition, when there is no
+ *    pending commands and the R2T queue is empty. It is unblocked when a client
+ *    register a new command, or when the TX server thread register a mew request
+ *    in the R2T queue.
+ *    The tx_valid flip-flop is SET by the client thread to signal a valid command. 
+ *    It is RESET by the server thread when the command is completed: For a SEND, 
+ *    all bytes have been sent (UDP) or acknowledged (TCP).
+ *
+ * 2) For an RX transfer, it can exist only one client thread for a given socket,
+ *    but the transfer is initiated by the remote process, and the  RECV command
+ *    is not really blocking: the data can arrive before the local RECV command is
+ *    executed, and the server thread does not wait to receive all requested data
+ *    to deliver data to client thread. Therefore each socket contains a receive
+ *    buffer (rx_buf) handled as a single-writer/single-reader fifo.
+ *    The client thread consumes data from the rx_buf when possible. It blocks on the
+ *    BLOCKED_IO condition and deschedules when the rx_buf is empty.
+ *    It is unblocked by the RX server thread when new data is available in the rx_buf.
+ *    The RX server blocks itself on the BLOCKED_ISR condition When the NIC_RX packets
+ *    queue is empty. It is unblocked by the hardware when new packets are available.
+ * 
+ * Note : the socket domains and types are defined in the "shared_socket.h" file.
+ ****************************************************************************************/
+
+/******************************************************************************************
+ * This function returns a printable string for a given NIC command <type>.
+ ******************************************************************************************
+ * @ type    : NIC command type
+ *****************************************************************************************/
+char * nic_cmd_str( uint32_t type );
+   
+/******************************************************************************************
+ * This function returns a printable string for a given socket <state>.
+ ******************************************************************************************
+ * @ state    : socket state
+ *****************************************************************************************/
+char * socket_state_str( uint32_t state );
 
 /******************************************************************************************
@@ -143,4 +299,6 @@
  * device and the specific data structures when required.
  * It creates the associated server thread and allocates a WTI from local ICU.
+ * For a TX_NIC chedv, it allocates and initializes the R2T waiting queue used by the 
+ * NIC_RX[channel] server to send direct requests to the NIC_TX[channel] server.
  * It must de executed by a local thread.
  ******************************************************************************************
